/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.clan.ClanUtils
 *  fire.pb.instancezone.act.Act
 *  fire.pb.instancezone.act.BattleAct
 *  fire.pb.instancezone.act.CompleteSubsaveAct
 *  fire.pb.instancezone.act.GotoAct
 *  fire.pb.instancezone.act.MessageAct
 *  fire.pb.instancezone.act.QuestionAct
 *  fire.pb.instancezone.act.SubmitItemAct
 *  fire.pb.instancezone.act.TaskAct
 *  fire.pb.instancezone.conf.ActionConfig
 *  fire.pb.instancezone.conf.InstanceZoneConfig
 *  fire.pb.instancezone.faction.FactionInstZone
 *  fire.pb.talk.MessageMgr
 *  mkdb.Transaction
 *  xbean.ClanInfo
 *  xbean.InstanceZone
 *  xbean.Pod
 *  xtable.Instancezones
 *  xtable.Properties
 *  xtable.Role2instancezone
 */
package fire.pb.instancezone;

import fire.pb.clan.ClanUtils;
import fire.pb.instancezone.InstanceZone;
import fire.pb.instancezone.Module;
import fire.pb.instancezone.act.Act;
import fire.pb.instancezone.act.BattleAct;
import fire.pb.instancezone.act.CompleteSubsaveAct;
import fire.pb.instancezone.act.GotoAct;
import fire.pb.instancezone.act.MessageAct;
import fire.pb.instancezone.act.QuestionAct;
import fire.pb.instancezone.act.SubmitItemAct;
import fire.pb.instancezone.act.TaskAct;
import fire.pb.instancezone.conf.ActionConfig;
import fire.pb.instancezone.conf.InstanceZoneConfig;
import fire.pb.instancezone.faction.FactionInstZone;
import fire.pb.talk.MessageMgr;
import java.util.List;
import java.util.Map;
import mkdb.Transaction;
import xbean.ClanInfo;
import xbean.Pod;
import xtable.Instancezones;
import xtable.Properties;
import xtable.Role2instancezone;

public abstract class InstanceZoneFactory {
    public static InstanceZone getInstanceZone(long landkey, boolean readonly) {
        if (landkey <= 0L) {
            return null;
        }
        xbean.InstanceZone xzone = null;
        if (!readonly) {
            if (Transaction.current() == null) {
                return null;
            }
            xzone = Instancezones.get((Long)landkey);
        } else {
            xzone = Instancezones.select((Long)landkey);
        }
        if (xzone == null) {
            return null;
        }
        InstanceZoneConfig zoneconfig = Module.getInstance().getInstanceZoneConfigs().get(xzone.getInstzoneid());
        if (zoneconfig == null) {
            return null;
        }
        Class<? extends InstanceZone> c = Module.getInstance().getId2Class().get(zoneconfig.instZoneId);
        try {
            InstanceZone instzone = c.getConstructor(Long.TYPE, xbean.InstanceZone.class, InstanceZoneConfig.class, Boolean.TYPE).newInstance(landkey, xzone, zoneconfig, readonly);
            return instzone;
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    public static InstanceZone getRoleCurInstanceZone(long roleId, boolean readonly) {
        Long landkey = Role2instancezone.select((Long)roleId);
        if (landkey == null) {
            return null;
        }
        return InstanceZoneFactory.getInstanceZone(landkey, readonly);
    }

    public static InstanceZone getInstanceZoneByFactionId(long factionId, int instid) {
        long factionkey = ClanUtils.getClanInstById((long)factionId, (int)instid);
        if (factionkey <= 0L) {
            return null;
        }
        return InstanceZoneFactory.getInstanceZone(factionkey, false);
    }

    public static InstanceZone getInstanceZoneByFactionRoleId(long roleid, int instid) {
        ClanInfo clanInfo = ClanUtils.getClanInfoById((long)roleid, (boolean)true);
        if (null == clanInfo) {
            return null;
        }
        return InstanceZoneFactory.getInstanceZoneByFactionId(clanInfo.getKey(), instid);
    }

    public static InstanceZone createInstanceZoneByRole(int landid, long roleId, long ownerId, boolean isGM) {
        if (Transaction.current() == null) {
            InstanceZone.logger.error((Object)("角色[" + roleId + "]在非事物中创建副本[" + landid + "],失败！"));
            return null;
        }
        InstanceZoneConfig zoneconfig = Module.getInstance().getInstanceZoneConfigs().get(landid);
        if (zoneconfig == null) {
            InstanceZone.logger.error((Object)("角色[" + roleId + "]未找到副本[" + landid + "]相关配置,失败！"));
            return null;
        }
        if (!InstanceZoneFactory.validCreate(roleId, zoneconfig) && !isGM) {
            InstanceZone.logger.error((Object)("角色[" + roleId + "]副本[" + landid + "]创建验证失败！"));
            return null;
        }
        Map initstates = zoneconfig.getInitInstanceSaves();
        if (initstates == null) {
            return null;
        }
        InstanceZone instzone = InstanceZoneFactory.createInstanceZone(landid, ownerId, initstates);
        if (instzone == null) {
            return null;
        }
        if (instzone instanceof FactionInstZone) {
            if (!ClanUtils.setClanInstByRoleId((long)roleId, (long)instzone.getLandkey(), (int)landid)) {
                return null;
            }
            long nowtime = System.currentTimeMillis();
            ((FactionInstZone)instzone).getClanInstData().getInstreset().put(landid, nowtime);
            Module.getInstance().setInstInit(instzone.getLandkey());
        }
        return instzone;
    }

    private static InstanceZone createInstanceZone(int landid, long ownerid, Map<Integer, Integer> initstates) {
        if (Transaction.current() == null) {
            return null;
        }
        InstanceZoneConfig zoneconfig = Module.getInstance().getInstanceZoneConfigs().get(landid);
        if (zoneconfig == null) {
            return null;
        }
        xbean.InstanceZone xzone = Pod.newInstanceZone();
        xzone.setInstzoneid(landid);
        xzone.setOwnerid(ownerid);
        xzone.setZonestate(1);
        xzone.setStarttime(zoneconfig.getEnterTime());
        Long landkey = Instancezones.insert((xbean.InstanceZone)xzone);
        if (landkey == null) {
            return null;
        }
        try {
            Class<? extends InstanceZone> c = Module.getInstance().getId2Class().get(landid);
            InstanceZone instzone = c.getConstructor(Long.TYPE, xbean.InstanceZone.class, InstanceZoneConfig.class, Boolean.TYPE).newInstance(landkey, xzone, zoneconfig, false);
            instzone.init(initstates);
            return instzone;
        }
        catch (Exception e) {
            Module.logger.error((Object)"Reflect new InstanceZone error : ", (Throwable)e);
            return null;
        }
    }

    public static Act createAction(ActionConfig actcfg, Map<String, Object> params) {
        if (actcfg == null) {
            return null;
        }
        MessageAct act = null;
        int actId = actcfg.servActId;
        try {
            switch (actcfg.type) {
                case 1: {
                    act = new MessageAct(actId, params);
                    return act;
                }
                case 2: {
                    act = new CompleteSubsaveAct(actId, params);
                    return act;
                }
                case 3: {
                    act = new TaskAct(actId, params);
                    return act;
                }
                case 4: {
                    act = new QuestionAct(actId, params);
                    return act;
                }
                case 5: {
                    act = new BattleAct(actId, params);
                    return act;
                }
                case 6: {
                    act = new SubmitItemAct(actId, params);
                    return act;
                }
                case 7: {
                    act = new GotoAct(actId, params);
                    return act;
                }
            }
        }
        catch (Exception e) {
            Module.logger.error((Object)("create act error，actid = " + actId), (Throwable)e);
        }
        return act;
    }

    static boolean validCreate(long roleId, InstanceZoneConfig zoneconfig) {
        int leaderlevel = Properties.selectLevel((Long)roleId);
        if (leaderlevel < zoneconfig.minlevel) {
            MessageMgr.psendMsgNotify((long)roleId, (int)142951, (List)MessageMgr.getStringList((Object[])new Object[]{zoneconfig.minlevel, zoneconfig.name}));
            InstanceZone.logger.error((Object)("角色[" + roleId + "]未达到副本[" + zoneconfig.instZoneId + "]最低等级,创建验证失败！"));
            return false;
        }
        if (leaderlevel > zoneconfig.maxlevel) {
            MessageMgr.psendMsgNotify((long)roleId, (int)142983, (List)MessageMgr.getStringList((Object[])new Object[]{zoneconfig.maxlevel, zoneconfig.name}));
            InstanceZone.logger.error((Object)("角色[" + roleId + "]已超过副本[" + zoneconfig.instZoneId + "]最高等级,创建验证失败！"));
            return false;
        }
        long now = System.currentTimeMillis();
        if (!zoneconfig.inEnterTime(now)) {
            MessageMgr.psendMsgNotify((long)roleId, (int)160364, null);
            InstanceZone.logger.error((Object)("角色[" + roleId + "]不在副本[" + zoneconfig.instZoneId + "]进入时间,创建验证失败！"));
            return false;
        }
        InstanceZone oldinstzone = InstanceZoneFactory.getInstanceZoneByFactionRoleId(roleId, zoneconfig.instZoneId);
        if (oldinstzone != null && !oldinstzone.canDestroy(false)) {
            oldinstzone.destroy(true, false);
        }
        return true;
    }
}

